// CODE C (Arduino) de description du TCO : Mon_TCO_No04_v4
// Généré par DELPHI/TCO_Web2 (Utpeca) le 30/03/2023 15:11:18
/*********************************************************************/

// Définition du nom du TCO
/*********************************************************************/
String nomTCO = "Mon_TCO_No04";

/*********************************************************************/
// Définition de la table des Appareils
/*********************************************************************/
typedef struct
{
  char   etaApp;    // état de l'appareil ( de '1' à '4')
  char   typApp;    // type de l'appareil ('A', 'X', 'T', 'Y')
  byte   noMot1;    // No du 1er moteur (de 1 à 8)
  byte   noMot2;    // No du 2me moteur (de 1 à 8)
  byte   noRcpt;    // No du ESP32/ESP8266 récepteur
} appareil;

#define NBMOT 8
appareil t_App[NBMOT] =
{
  {'2', 'A', 1, 0, 1},
  {'4', 'X', 2, 3, 1},
  {'1', 'Y', 4, 0, 2},
  {'3', 'T', 5, 6, 2},
  {'1', ' ', 0, 0, 0},
  {'1', ' ', 0, 0, 0},
  {'1', ' ', 0, 0, 0},
  {'1', ' ', 0, 0, 0}
};

/*********************************************************************/
// Définition de la table des Sections de voie
/*********************************************************************/
typedef struct
{
  String nomSek;    // nom de la section
  char   etaSek;    // état de la section ( '1' alimenté, '0' sinon)
  byte   no_Rel;    // No du relais (de 1 à 8)
  byte   noRcpt;    // No du ESP32/ESP8266 récepteur
} section;

#define NBSEK 9
section t_Sek[NBSEK] =
{
  {"C001", '0', 1, 4},
  {"C002", '0', 2, 4},
  {"C003", '0', 3, 4},
  {"C004", '0', 4, 4},
  {"C005", '0', 5, 4},
  {"C006", '0', 6, 4},
  {"C007", '0', 7, 4},
  {"C008", '0', 8, 4},
  {"C009", '0', 1, 3}
};

// Remplacer %CONSTRUIRE_TCO% par la table HTML des vignettes
/*********************************************************************/
String processor(const String& var)
{
  if (var == "CONSTRUIRE_TCO")
  {
    String tco = "";
    tco += "<table border='0' cellspacing='0' cellpadding='0'><tr>\n";
    tco += "<tr>\n";
    tco += "<td> <img class='ang000' src='Sign' id='X00Y00'></td>\n"; 
    tco += "<td> <img class='ang000' src='vide' id='X01Y00'></td>\n"; 
    tco += "<td> <img class='ang000' src='vide' id='X02Y00'></td>\n"; 
    tco += "<td> <img class='ang000' src='vide' id='X03Y00'></td>\n"; 
    tco += "<td> <img class='ang000' src='vide' id='X04Y00'></td>\n"; 
    tco += "<td> <img class='ang000' src='vide' id='X05Y00'></td>\n"; 
    tco += "<td> <img class='ang000' src='vide' id='X06Y00'></td>\n"; 
    tco += "<td> <img class='ang000' src='vide' id='X07Y00'></td>\n"; 
    tco += "<td> <img class='ang000' src='vide' id='X08Y00'></td>\n"; 
    tco += "<td> <img class='ang000' src='vide' id='X09Y00'></td>\n"; 
    tco += "<td> <img class='ang000' src='vide' id='X10Y00'></td>\n"; 
    tco += "<td> <img class='ang180' src='VirG1' id='X11Y00'></td>\n"; 
    tco += "<td> <img class='ang000' src='H1' id='X12Y00'></td>\n"; 
    tco += "<td> <img class='ang000' src='H1' id='X13Y00'></td>\n"; 
    tco += "<td> <a href='javascript:;' onClick=\"CalculeIti('X14Y00', 'But5')\"\n"; 
    tco += "      onmouseover=\"AfficheEtiq('But1', 'X14Y00')\" onmouseout=\"EffaceEtiq('X14Y00')\">\n"; 
    tco += "     <img class='ang180' src='But5' id='X14Y00'></td>\n"; 
    tco += "</tr>\n";
    tco += "<tr>\n";
    tco += "<td> <a href='javascript:;' onClick=\"CalculeIti('X00Y01', 'But5')\"\n"; 
    tco += "      onmouseover=\"AfficheEtiq('But2', 'X00Y01')\" onmouseout=\"EffaceEtiq('X00Y01')\">\n"; 
    tco += "     <img class='ang000' src='But5' id='X00Y01'></td>\n"; 
    tco += "<td> <img class='ang000' src='H1' id='X01Y01'></td>\n"; 
    tco += "<td> <img class='ang000' src='H1' id='X02Y01'></td>\n"; 
    tco += "<td> <a href='javascript:;' onClick=\"posApp1=ChangeAig(posApp1, 'Aig1', 'AigD1')\"\n"; 
    tco += "      onmouseover=\"AfficheEtiq('Aig1', 'X03Y01')\" onmouseout=\"EffaceEtiq('X03Y01')\">\n"; 
    tco += "     <img class='ang000' src='AigD1_E2' name='imgAig1' id='X03Y01'></td>\n"; 
    tco += "<td> <img class='ang000' src='H1' id='X04Y01'></td>\n"; 
    tco += "<td> <img class='ang000' src='H1' id='X05Y01'></td>\n"; 
    tco += "<td> <img class='ang000' src='H1' id='X06Y01'></td>\n"; 
    tco += "<td> <img class='ang000' src='H1' id='X07Y01'></td>\n"; 
    tco += "<td> <img class='ang000' src='H1' id='X08Y01'></td>\n"; 
    tco += "<td> <img class='ang000' src='H1' id='X09Y01'></td>\n"; 
    tco += "<td> <a href='javascript:;' onClick=\"posApp2=ChangeTjd(posApp2, 'Aig2', 'Crois1')\"\n"; 
    tco += "      onmouseover=\"AfficheEtiq('Aig2', 'X10Y01')\" onmouseout=\"EffaceEtiq('X10Y01')\">\n"; 
    tco += "     <img class='ang000' src='Crois1_E4' name='imgAig2' id='X10Y01'></td>\n"; 
    tco += "<td> <img class='ang000' src='H1' id='X11Y01'></td>\n"; 
    tco += "<td> <img class='ang000' src='H1' id='X12Y01'></td>\n"; 
    tco += "<td> <img class='ang000' src='VirD1' id='X13Y01'></td>\n"; 
    tco += "<td> <img class='ang000' src='vide' id='X14Y01'></td>\n"; 
    tco += "</tr>\n";
    tco += "<tr>\n";
    tco += "<td> <img class='ang000' src='vide' id='X00Y02'></td>\n"; 
    tco += "<td> <img class='ang000' src='vide' id='X01Y02'></td>\n"; 
    tco += "<td> <img class='ang000' src='vide' id='X02Y02'></td>\n"; 
    tco += "<td> <img class='ang000' src='vide' id='X03Y02'></td>\n"; 
    tco += "<td> <img class='ang180' src='VirD1' id='X04Y02'></td>\n"; 
    tco += "<td> <img class='ang000' src='H1' id='X05Y02'></td>\n"; 
    tco += "<td> <img class='ang000' src='H1' id='X06Y02'></td>\n"; 
    tco += "<td> <img class='ang000' src='H1' id='X07Y02'></td>\n"; 
    tco += "<td> <img class='ang000' src='H1' id='X08Y02'></td>\n"; 
    tco += "<td> <img class='ang000' src='VirG1' id='X09Y02'></td>\n"; 
    tco += "<td> <img class='ang000' src='vide' id='X10Y02'></td>\n"; 
    tco += "<td> <img class='ang000' src='vide' id='X11Y02'></td>\n"; 
    tco += "<td> <img class='ang000' src='vide' id='X12Y02'></td>\n"; 
    tco += "<td> <img class='ang000' src='vide' id='X13Y02'></td>\n"; 
    tco += "<td> <img class='ang090' src='VirG1' id='X14Y02'></td>\n"; 
    tco += "</tr>\n";
    tco += "<tr>\n";
    tco += "<td> <img class='ang000' src='vide' id='X00Y03'></td>\n"; 
    tco += "<td> <img class='ang000' src='vide' id='X01Y03'></td>\n"; 
    tco += "<td> <img class='ang000' src='vide' id='X02Y03'></td>\n"; 
    tco += "<td> <img class='ang000' src='vide' id='X03Y03'></td>\n"; 
    tco += "<td> <img class='ang180' src='VirG1' id='X04Y03'></td>\n"; 
    tco += "<td> <img class='ang000' src='H1' id='X05Y03'></td>\n"; 
    tco += "<td> <img class='ang000' src='H1' id='X06Y03'></td>\n"; 
    tco += "<td> <img class='ang000' src='H1' id='X07Y03'></td>\n"; 
    tco += "<td> <img class='ang000' src='H1' id='X08Y03'></td>\n"; 
    tco += "<td> <img class='ang000' src='H1' id='X09Y03'></td>\n"; 
    tco += "<td> <img class='ang000' src='VirD1' id='X10Y03'></td>\n"; 
    tco += "<td> <img class='ang000' src='vide' id='X11Y03'></td>\n"; 
    tco += "<td> <img class='ang000' src='vide' id='X12Y03'></td>\n"; 
    tco += "<td> <img class='ang000' src='vide' id='X13Y03'></td>\n"; 
    tco += "<td> <img class='ang270' src='VirD1' id='X14Y03'></td>\n"; 
    tco += "</tr>\n";
    tco += "<tr>\n";
    tco += "<td> <a href='javascript:;' onClick=\"CalculeIti('X00Y04', 'But5')\"\n"; 
    tco += "      onmouseover=\"AfficheEtiq('But3', 'X00Y04')\" onmouseout=\"EffaceEtiq('X00Y04')\">\n"; 
    tco += "     <img class='ang000' src='But5' id='X00Y04'></td>\n"; 
    tco += "<td> <img class='ang000' src='H1' id='X01Y04'></td>\n"; 
    tco += "<td> <img class='ang000' src='H1' id='X02Y04'></td>\n"; 
    tco += "<td> <a href='javascript:;' onClick=\"posApp3=ChangeAigS(posApp3, 'Aig3', 'AigS1')\"\n"; 
    tco += "      onmouseover=\"AfficheEtiq('Aig3', 'X03Y04')\" onmouseout=\"EffaceEtiq('X03Y04')\">\n"; 
    tco += "     <img class='ang000' src='AigS1_E1' name='imgAig3' id='X03Y04'></td>\n"; 
    tco += "<td> <img class='ang000' src='vide' id='X04Y04'></td>\n"; 
    tco += "<td> <a href='javascript:;' onClick=\"CalculeIti('X05Y04', 'But5')\"\n"; 
    tco += "      onmouseover=\"AfficheEtiq('But4', 'X05Y04')\" onmouseout=\"EffaceEtiq('X05Y04')\">\n"; 
    tco += "     <img class='ang000' src='But5' id='X05Y04'></td>\n"; 
    tco += "<td> <img class='ang000' src='H1' id='X06Y04'></td>\n"; 
    tco += "<td> <img class='ang000' src='H1' id='X07Y04'></td>\n"; 
    tco += "<td> <img class='ang000' src='H1' id='X08Y04'></td>\n"; 
    tco += "<td> <img class='ang000' src='H1' id='X09Y04'></td>\n"; 
    tco += "<td> <img class='ang000' src='H1' id='X10Y04'></td>\n"; 
    tco += "<td> <a href='javascript:;' onClick=\"posApp4=ChangeAigT(posApp4, 'Aig4', 'AigT1')\"\n"; 
    tco += "      onmouseover=\"AfficheEtiq('Aig4', 'X11Y04')\" onmouseout=\"EffaceEtiq('X11Y04')\">\n"; 
    tco += "     <img class='ang180' src='AigT1_E3' name='imgAig4' id='X11Y04'></td>\n"; 
    tco += "<td> <img class='ang000' src='H1' id='X12Y04'></td>\n"; 
    tco += "<td> <img class='ang000' src='VirG1' id='X13Y04'></td>\n"; 
    tco += "<td> <img class='ang000' src='vide' id='X14Y04'></td>\n"; 
    tco += "</tr>\n";
    tco += "<tr>\n";
    tco += "<td> <img class='ang000' src='vide' id='X00Y05'></td>\n"; 
    tco += "<td> <img class='ang000' src='vide' id='X01Y05'></td>\n"; 
    tco += "<td> <img class='ang000' src='vide' id='X02Y05'></td>\n"; 
    tco += "<td> <img class='ang000' src='vide' id='X03Y05'></td>\n"; 
    tco += "<td> <img class='ang180' src='VirD1' id='X04Y05'></td>\n"; 
    tco += "<td> <img class='ang000' src='H1' id='X05Y05'></td>\n"; 
    tco += "<td> <img class='ang000' src='H1' id='X06Y05'></td>\n"; 
    tco += "<td> <img class='ang000' src='H1' id='X07Y05'></td>\n"; 
    tco += "<td> <img class='ang000' src='H1' id='X08Y05'></td>\n"; 
    tco += "<td> <img class='ang000' src='H1' id='X09Y05'></td>\n"; 
    tco += "<td> <img class='ang000' src='VirG1' id='X10Y05'></td>\n"; 
    tco += "<td> <img class='ang000' src='vide' id='X11Y05'></td>\n"; 
    tco += "<td> <img class='ang000' src='vide' id='X12Y05'></td>\n"; 
    tco += "<td> <img class='ang000' src='vide' id='X13Y05'></td>\n"; 
    tco += "<td> <img class='ang000' src='vide' id='X14Y05'></td>\n"; 
    tco += "</tr>\n";
    tco += "</table>\n";
    return tco;
  }
  else if (var == "NOM_DU_TCO")  { return nomTCO; }
  else return String();
}

/*********************************************************************/
void ChargerVignettes()
/*********************************************************************/
// Route pour charger TCOWeb4.css file, TCOWeb4.js file et les vignettes
{
  server.on("/TCOWeb4.css", HTTP_GET, [](AsyncWebServerRequest * request)
    { request->send(SPIFFS, "/TCOWeb4.css", "text/css"); });
  server.on("/TCOWeb4.js", HTTP_GET, [](AsyncWebServerRequest *request)
    { request->send(SPIFFS, "/TCOWeb4.js", "text/javascript"); });
  server.on("/Mon_TCO_No04", HTTP_GET, [](AsyncWebServerRequest *request)
    { request->send(SPIFFS, "/Mon_TCO_No04.js", "text/javascript"); });

  server.on("/Pierre", HTTP_GET, [](AsyncWebServerRequest *request)
    { request->send(SPIFFS, "/Pierre.gif", "image/gif"); });
  server.on("/Ligne", HTTP_GET, [](AsyncWebServerRequest *request)
    { request->send(SPIFFS, "/Ligne.gif", "image/gif"); });
  server.on("/Titre1", HTTP_GET, [](AsyncWebServerRequest *request)
    { request->send(SPIFFS, "/Titre1.gif", "image/gif"); });
  server.on("/Locoduino", HTTP_GET, [](AsyncWebServerRequest *request)
    { request->send(SPIFFS, "/Locoduino.gif", "image/gif"); });
  server.on("/Icon1", HTTP_GET, [](AsyncWebServerRequest *request)
    { request->send(SPIFFS, "/Icon1.png", "image/png"); });
  server.on("/Pierre60x40", HTTP_GET, [](AsyncWebServerRequest *request)
    { request->send(SPIFFS, "/Pierre60x40.png", "image/png"); });
  server.on("/Sign", HTTP_GET, [](AsyncWebServerRequest *request)
    { request->send(SPIFFS, "/Sign.png", "image/png"); });
  server.on("/vide", HTTP_GET, [](AsyncWebServerRequest *request)
    { request->send(SPIFFS, "/vide.png", "image/png"); });
  server.on("/VirG1", HTTP_GET, [](AsyncWebServerRequest *request)
    { request->send(SPIFFS, "/VirG1.png", "image/png"); });
  server.on("/VirG1_I5", HTTP_GET, [](AsyncWebServerRequest *request)
    { request->send(SPIFFS, "/VirG1_I5.png", "image/png"); });
  server.on("/VirG1_I6", HTTP_GET, [](AsyncWebServerRequest *request)
    { request->send(SPIFFS, "/VirG1_I6.png", "image/png"); });
  server.on("/H1", HTTP_GET, [](AsyncWebServerRequest *request)
    { request->send(SPIFFS, "/H1.png", "image/png"); });
  server.on("/H1_I5", HTTP_GET, [](AsyncWebServerRequest *request)
    { request->send(SPIFFS, "/H1_I5.png", "image/png"); });
  server.on("/H1_I6", HTTP_GET, [](AsyncWebServerRequest *request)
    { request->send(SPIFFS, "/H1_I6.png", "image/png"); });
  server.on("/But5", HTTP_GET, [](AsyncWebServerRequest *request)
    { request->send(SPIFFS, "/But5.png", "image/png"); });
  server.on("/But5_I5", HTTP_GET, [](AsyncWebServerRequest *request)
    { request->send(SPIFFS, "/But5_I5.png", "image/png"); });
  server.on("/But5_I6", HTTP_GET, [](AsyncWebServerRequest *request)
    { request->send(SPIFFS, "/But5_I6.png", "image/png"); });
  server.on("/AigD1_E1", HTTP_GET, [](AsyncWebServerRequest *request)
    { request->send(SPIFFS, "/AigD1_E1.png", "image/png"); });
  server.on("/AigD1_E2", HTTP_GET, [](AsyncWebServerRequest *request)
    { request->send(SPIFFS, "/AigD1_E2.png", "image/png"); });
  server.on("/Crois1_E1", HTTP_GET, [](AsyncWebServerRequest *request)
    { request->send(SPIFFS, "/Crois1_E1.png", "image/png"); });
  server.on("/Crois1_E2", HTTP_GET, [](AsyncWebServerRequest *request)
    { request->send(SPIFFS, "/Crois1_E2.png", "image/png"); });
  server.on("/Crois1_E3", HTTP_GET, [](AsyncWebServerRequest *request)
    { request->send(SPIFFS, "/Crois1_E3.png", "image/png"); });
  server.on("/Crois1_E4", HTTP_GET, [](AsyncWebServerRequest *request)
    { request->send(SPIFFS, "/Crois1_E4.png", "image/png"); });
  server.on("/VirD1", HTTP_GET, [](AsyncWebServerRequest *request)
    { request->send(SPIFFS, "/VirD1.png", "image/png"); });
  server.on("/VirD1_I5", HTTP_GET, [](AsyncWebServerRequest *request)
    { request->send(SPIFFS, "/VirD1_I5.png", "image/png"); });
  server.on("/VirD1_I6", HTTP_GET, [](AsyncWebServerRequest *request)
    { request->send(SPIFFS, "/VirD1_I6.png", "image/png"); });
  server.on("/AigS1_E1", HTTP_GET, [](AsyncWebServerRequest *request)
    { request->send(SPIFFS, "/AigS1_E1.png", "image/png"); });
  server.on("/AigS1_E2", HTTP_GET, [](AsyncWebServerRequest *request)
    { request->send(SPIFFS, "/AigS1_E2.png", "image/png"); });
  server.on("/AigT1_E1", HTTP_GET, [](AsyncWebServerRequest *request)
    { request->send(SPIFFS, "/AigT1_E1.png", "image/png"); });
  server.on("/AigT1_E2", HTTP_GET, [](AsyncWebServerRequest *request)
    { request->send(SPIFFS, "/AigT1_E2.png", "image/png"); });
  server.on("/AigT1_E3", HTTP_GET, [](AsyncWebServerRequest *request)
    { request->send(SPIFFS, "/AigT1_E3.png", "image/png"); });
}
